function [cycle,smoothed] = filtering_diff4(yy,param)
%warning on;
dbstop if warning

global START
T=length(yy);

PR=param;

     SN=PR(1);  
     SE=PR(2); 
     SE1=PR(3);
     SV=PR(4);
     SV1=PR(5);
     phi1=PR(6);
     phi2=PR(7);
     a=PR(8);
     b=PR(9);    
     SW=PR(10);
   
         

           R=SN^2;


 
     
      F=[1,0,0,0,0;0,phi1,phi2,0,0;0,1,0,0,0;0,0,0,0,0;0,0,0,1,0];
     F1 = F(2:5,2:5); %pick out I(0) part @
     
     
    H=[1,1,-1,1,-1];

     
    
     G=eye(5);

            % Define 4 states of the variances   
    Q0=[SV^2,0,0,0,0;0,SE^2,0,0,0;0,0,0,0,0;0,0,0,SW^2,0;0,0,0,0,0];                
    Q1=[SV1^2,0,0,0,0;0,SE^2,0,0,0;0,0,0,0,0;0,0,0,SW^2,0;0,0,0,0,0];              
    Q2=[SV^2,0,0,0,0;0,SE1^2,0,0,0;0,0,0,0,0;0,0,0,SW^2,0;0,0,0,0,0];
    Q3=[SV1^2,0,0,0,0;0,SE1^2,0,0,0;0,0,0,0,0;0,0,0,SW^2,0;0,0,0,0,0]; 
     R= SN^2;%           @ cov matrix of error in measurement eqn @

   

     cycle=zeros(T,5);

     smoothed=zeros(T,5);
     
   
    
     BETA_LL=[0.95;0;0;0;0];%             @ starting values @
     BETA_LL0=BETA_LL;
     BETA_LL1=BETA_LL;
     BETA_LL2=BETA_LL;
     BETA_LL3=BETA_LL;
   
 QQ1=[a*SE^2+(1-a)*SE1^2,0,0,0;0,0,0,0;0,0,SW^2,0;0,0,0,0];
     
%      % variance matrix of initial state vector 
          P_LL0 = zeros(5,5);
          P_LLI = inv((eye(16)-kron(F1,F1)))*reshape(QQ1,16,1);
          P_LLI = reshape(P_LLI',4,4);
        
     
   
         P_LL0(2:5,2:5)=P_LLI;

       
           P_LL0(1,1)=1e-5;

         
         
         
         P_LL1=P_LL0;
         P_LL2=P_LL0;
         P_LL2=P_LL0;
         P_LL3=P_LL0;
     
     
     likeli=0;
     
     BE_tt0=zeros(5,T);
     BE_tt1=zeros(5,T);
     BE_tt2=zeros(5,T);
     BE_tt3=zeros(5,T);
     
     P_tt0 =zeros(5,5,T);
     P_tt1 =zeros(5,5,T);
     P_tt2 =zeros(5,5,T);
     P_tt3 =zeros(5,5,T);
     
     BE_tl00=zeros(5,T);
     BE_tl01=zeros(5,T);
     BE_tl02=zeros(5,T);
     BE_tl03=zeros(5,T);
     
     
     BE_tl10=zeros(5,T);
     BE_tl11=zeros(5,T);
     BE_tl12=zeros(5,T);
     BE_tl13=zeros(5,T);
     
     BE_tl20=zeros(5,T);
     BE_tl21=zeros(5,T);
     BE_tl22=zeros(5,T);
     BE_tl23=zeros(5,T);
     
     BE_tl30=zeros(5,T);
     BE_tl31=zeros(5,T);
     BE_tl32=zeros(5,T);
     BE_tl33=zeros(5,T);
     
     
     
     P_tl00 =zeros(5,5,T);
     P_tl01 =zeros(5,5,T);
     P_tl02 =zeros(5,5,T);
     P_tl03 =zeros(5,5,T);
      
     P_tl10 =zeros(5,5,T);
     P_tl11 =zeros(5,5,T);
     P_tl12 =zeros(5,5,T);
     P_tl13 =zeros(5,5,T);
     
     P_tl20 =zeros(5,5,T);
     P_tl21 =zeros(5,5,T);
     P_tl22 =zeros(5,5,T);
     P_tl23 =zeros(5,5,T);
     
     P_tl30 =zeros(5,5,T);
     P_tl31 =zeros(5,5,T);
     P_tl32 =zeros(5,5,T);
     P_tl33 =zeros(5,5,T);
   
     Pr_tl0=zeros(T,1);
     Pr_tl1=zeros(T,1);
     Pr_tl2=zeros(T,1);
     Pr_tl3=zeros(T,1);
    
     Pr_tt0=zeros(T,1);
     Pr_tt1=zeros(T,1);
     Pr_tt2=zeros(T,1);
     Pr_tt3=zeros(T,1);
     
     
     prob0=a*b;
     prob1=a*(1-b);
     prob2=(1-a)*b;
     prob3=(1-a)*(1-b);  
     
     cycle=zeros(T,4);
     
     
for  J_ITER=1:T 
    
      Pr_tl0(J_ITER) = a     * b ;          % Pr(lam; Y(-1))
      Pr_tl1(J_ITER) = a     * (1-b) ;
      Pr_tl2(J_ITER) = (1-a) * b ;
      Pr_tl3(J_ITER) = (1-a) * (1-b) ;
 
        % one step ahead
      BETA_TL00 = F*BETA_LL0;    
      BETA_TL01 = F*BETA_LL0; 
      BETA_TL02 = F*BETA_LL0;
      BETA_TL03 = F*BETA_LL0;
      
      BETA_TL10 = F*BETA_LL1; 
      BETA_TL11 = F*BETA_LL1;  
      BETA_TL12 = F*BETA_LL1; 
      BETA_TL13 = F*BETA_LL1;  
      
      BETA_TL20 = F*BETA_LL2; 
      BETA_TL21 = F*BETA_LL2;  
      BETA_TL22 = F*BETA_LL2; 
      BETA_TL23 = F*BETA_LL2;
      
      BETA_TL30 = F*BETA_LL3; 
      BETA_TL31 = F*BETA_LL3;  
      BETA_TL32 = F*BETA_LL3; 
      BETA_TL33 = F*BETA_LL3;
        
        
      
      % one step ahead predictor
      P_TL00 = F*P_LL0*F' + G*Q0*G';  
      P_TL01 = F*P_LL0*F' + G*Q1*G';  
      P_TL02 = F*P_LL0*F' + G*Q2*G';
      P_TL03 = F*P_LL0*F' + G*Q3*G';
      
      P_TL10 = F*P_LL1*F' + G*Q0*G';  
      P_TL11 = F*P_LL1*F' + G*Q1*G';  
      P_TL12 = F*P_LL1*F' + G*Q2*G';
      P_TL13 = F*P_LL1*F' + G*Q3*G';
      
      P_TL20 = F*P_LL2*F' + G*Q0*G';  
      P_TL21 = F*P_LL2*F' + G*Q1*G';  
      P_TL22 = F*P_LL2*F' + G*Q2*G';
      P_TL23 = F*P_LL2*F' + G*Q3*G';
      
      P_TL30 = F*P_LL3*F' + G*Q0*G';  
      P_TL31 = F*P_LL3*F' + G*Q1*G';  
      P_TL32 = F*P_LL3*F' + G*Q2*G';
      P_TL33 = F*P_LL3*F' + G*Q3*G';
      
    
      % forecast error
      vt00=yy(J_ITER,1) - H * BETA_TL00; 
      vt01=yy(J_ITER,1) - H * BETA_TL01; 
      vt02=yy(J_ITER,1) - H * BETA_TL02; 
      vt03=yy(J_ITER,1) - H * BETA_TL03; 
      
      vt10=yy(J_ITER,1) - H * BETA_TL10; 
      vt11=yy(J_ITER,1) - H * BETA_TL11; 
      vt12=yy(J_ITER,1) - H * BETA_TL12; 
      vt13=yy(J_ITER,1) - H * BETA_TL13; 
      
      vt20=yy(J_ITER,1) - H * BETA_TL20; 
      vt21=yy(J_ITER,1) - H * BETA_TL21; 
      vt22=yy(J_ITER,1) - H * BETA_TL22; 
      vt23=yy(J_ITER,1) - H * BETA_TL23; 
      
      vt30=yy(J_ITER,1) - H * BETA_TL30; 
      vt31=yy(J_ITER,1) - H * BETA_TL31; 
      vt32=yy(J_ITER,1) - H * BETA_TL32; 
      vt33=yy(J_ITER,1) - H * BETA_TL33; 
     
      
      
      %   variance of forecast error
      ft00= H * P_TL00 * H' + R;  
      ft01= H * P_TL01 * H' + R;  
      ft02= H * P_TL02 * H' + R;  
      ft03= H * P_TL03 * H' + R;  
      
      ft10= H * P_TL10 * H' + R;  
      ft11= H * P_TL11 * H' + R;  
      ft12= H * P_TL12 * H' + R;  
      ft13= H * P_TL13 * H' + R;  
      
      ft20= H * P_TL20 * H' + R;  
      ft21= H * P_TL21 * H' + R;  
      ft22= H * P_TL22 * H' + R;  
      ft23= H * P_TL23 * H' + R;  
      
      ft30= H * P_TL30 * H' + R;  
      ft31= H * P_TL31 * H' + R;  
      ft32= H * P_TL32 * H' + R;  
      ft33= H * P_TL33 * H' + R;  
    
      
      
      % filtering
      BETA_TT00 = BETA_TL00 + P_TL00 * H' * inv(ft00) * vt00;
      BETA_TT01 = BETA_TL01 + P_TL01 * H' * inv(ft01) * vt01;
      BETA_TT02 = BETA_TL02 + P_TL02 * H' * inv(ft02) * vt02;
      BETA_TT03 = BETA_TL03 + P_TL03 * H' * inv(ft03) * vt03;
      
      BETA_TT10 = BETA_TL10 + P_TL10 * H' * inv(ft10) * vt10;
      BETA_TT11 = BETA_TL11 + P_TL11 * H' * inv(ft11) * vt11;
      BETA_TT12 = BETA_TL12 + P_TL12 * H' * inv(ft12) * vt12;
      BETA_TT13 = BETA_TL13 + P_TL13 * H' * inv(ft13) * vt13;
      
      BETA_TT20 = BETA_TL20 + P_TL20 * H' * inv(ft20) * vt20;
      BETA_TT21 = BETA_TL21 + P_TL21 * H' * inv(ft21) * vt21;
      BETA_TT22 = BETA_TL22 + P_TL22 * H' * inv(ft22) * vt22;
      BETA_TT23 = BETA_TL23 + P_TL23 * H' * inv(ft23) * vt23;
      
      BETA_TT30 = BETA_TL30 + P_TL30 * H' * inv(ft30) * vt30;
      BETA_TT31 = BETA_TL31 + P_TL31 * H' * inv(ft31) * vt31;
      BETA_TT32 = BETA_TL32 + P_TL32 * H' * inv(ft32) * vt32;
      BETA_TT33 = BETA_TL33 + P_TL33 * H' * inv(ft33) * vt33;
      
      
      P_TT00= P_TL00 - P_TL00 * H' * inv(ft00) * H * P_TL00;
      P_TT01= P_TL01 - P_TL01 * H' * inv(ft01) * H * P_TL01;
      P_TT02= P_TL02 - P_TL02 * H' * inv(ft02) * H * P_TL02;
      P_TT03= P_TL03 - P_TL03 * H' * inv(ft03) * H * P_TL03;
      
      P_TT10= P_TL10 - P_TL10 * H' * inv(ft10) * H * P_TL10;
      P_TT11= P_TL11 - P_TL11 * H' * inv(ft11) * H * P_TL11;
      P_TT12= P_TL12 - P_TL12 * H' * inv(ft12) * H * P_TL12;
      P_TT13= P_TL13 - P_TL13 * H' * inv(ft13) * H * P_TL13;
      
      P_TT20= P_TL20 - P_TL20 * H' * inv(ft20) * H * P_TL20;
      P_TT21= P_TL21 - P_TL21 * H' * inv(ft21) * H * P_TL21;
      P_TT22= P_TL22 - P_TL22 * H' * inv(ft22) * H * P_TL22;
      P_TT23= P_TL23 - P_TL23 * H' * inv(ft23) * H * P_TL23;
      
      P_TT30= P_TL30 - P_TL30 * H' * inv(ft30) * H * P_TL30;
      P_TT31= P_TL31 - P_TL31 * H' * inv(ft31) * H * P_TL31;
      P_TT32= P_TL32 - P_TL32 * H' * inv(ft32) * H * P_TL32;
      P_TT33= P_TL33 - P_TL33 * H' * inv(ft33) * H * P_TL33;
  
      
 
      
     
      
      
      
     
    
     
      % making likelihood
      PV_00 = vprob(vt00,ft00) * a*b       * prob0;            % making f(y|Y(-1)) =  f(y|lam,lam(-1),Y(-1)) * Prob( lam,lam(-1)| Y(-1))
      PV_01 = vprob(vt01,ft01) * a*(1-b)   * prob0;            %       Pr(lam,lam(-1)| Y(-1)) = Pr(lam|lam(-1)) * Pr(lam(-1)| Y(-1)) 
      PV_02 = vprob(vt02,ft02) *(1-a)*b    * prob0;
      PV_03 = vprob(vt03,ft03) *(1-a)*(1-b)* prob0;
  
      PV_10 = vprob(vt10,ft10) * a*b       * prob1;          
      PV_11 = vprob(vt11,ft11) * a*(1-b)   * prob1;             
      PV_12 = vprob(vt12,ft12) *(1-a)*b    * prob1;
      PV_13 = vprob(vt13,ft13) *(1-a)*(1-b)* prob1;
     
      PV_20 = vprob(vt20,ft20) * a*b       * prob2;          
      PV_21 = vprob(vt21,ft21) * a*(1-b)   * prob2;             
      PV_22 = vprob(vt22,ft22) *(1-a)*b    * prob2;
      PV_23 = vprob(vt23,ft23) *(1-a)*(1-b)* prob2;
      
      PV_30 = vprob(vt30,ft30) * a*b       * prob3;          
      PV_31 = vprob(vt31,ft31) * a*(1-b)   * prob3;             
      PV_32 = vprob(vt32,ft32) *(1-a)*b    * prob3;
      PV_33 = vprob(vt33,ft33) *(1-a)*(1-b)* prob3;
      
     
      
      likeli = PV_00 + PV_01 + PV_02 + PV_03...
          +PV_10 + PV_11 + PV_12 + PV_13...
          +PV_20 + PV_21 + PV_22 + PV_23...
          +PV_30 + PV_31 + PV_32 + PV_33;          
    
      LL(J_ITER)=likeli;
      Cd(J_ITER,:)=[vprob(vt00,ft00),vprob(vt01,ft01),vprob(vt02,ft02),vprob(vt03,ft03),...
          vprob(vt10,ft10),vprob(vt11,ft11),vprob(vt12,ft12),vprob(vt13,ft13),...
          vprob(vt20,ft20),vprob(vt21,ft21),vprob(vt22,ft22),vprob(vt23,ft23),...
                             vprob(vt30,ft30),vprob(vt31,ft31),vprob(vt32,ft32),vprob(vt33,ft33)];
      
      % Pr(lam,lam(-1); Y) = f( y;lam,lam(-1),Y(-1)) * Pr(lam,lam(-1); Y(-1)) / f( y; Y(-1)): update  
      Pr00 = PV_00 / likeli;         
      Pr01 = PV_01 / likeli;
      Pr02 = PV_02 / likeli;
      Pr03 = PV_03 / likeli;
     
      Pr10 = PV_10 / likeli;         
      Pr11 = PV_11 / likeli;
      Pr12 = PV_12 / likeli;
      Pr13 = PV_13 / likeli;
      
      Pr20 = PV_20 / likeli;         
      Pr21 = PV_21 / likeli;
      Pr22 = PV_22 / likeli;
      Pr23 = PV_23 / likeli;
      
      Pr30 = PV_30 / likeli;         
      Pr31 = PV_31 / likeli;
      Pr32 = PV_32 / likeli;
      Pr33 = PV_33 / likeli;
      
      PRO_00(J_ITER)=Pr00;
      PRO_01(J_ITER)=Pr01;
      PRO_02(J_ITER)=Pr02;
      PRO_03(J_ITER)=Pr03;
      
      PRO_10(J_ITER)=Pr10;
      PRO_11(J_ITER)=Pr11;
      PRO_12(J_ITER)=Pr12;
      PRO_13(J_ITER)=Pr13;
      
      PRO_20(J_ITER)=Pr20;
      PRO_21(J_ITER)=Pr21;
      PRO_22(J_ITER)=Pr22;
      PRO_23(J_ITER)=Pr23;
      
      PRO_30(J_ITER)=Pr30;
      PRO_31(J_ITER)=Pr31;
      PRO_32(J_ITER)=Pr32;
      PRO_33(J_ITER)=Pr33;
      
      
      
      
      
       B_TT = BETA_TT00*Pr00 + BETA_TT01*Pr01 + BETA_TT02*Pr02 + BETA_TT03*Pr03...
           +BETA_TT10*Pr10 + BETA_TT11*Pr11 + BETA_TT12*Pr12 + BETA_TT13*Pr13...
           +BETA_TT20*Pr20 + BETA_TT21*Pr21 + BETA_TT22*Pr22 + BETA_TT23*Pr23...
           +BETA_TT30*Pr30 + BETA_TT31*Pr31 + BETA_TT32*Pr32 + BETA_TT33*Pr33;
      
% filtered process       
       cycle(J_ITER,1) = B_TT(1);
       cycle(J_ITER,2) = B_TT(2);
       cycle(J_ITER,3) = B_TT(3);
       cycle(J_ITER,4) = B_TT(4);
      
       
       
       
      prob0 = Pr00 + Pr10 + Pr20 + Pr30;  % Pr(lam| Y), lam=1       Pr( lam | Y) = sum Pr(lam,lam(-1)| Y)
      prob1 = Pr01 + Pr11 + Pr21 + Pr31;  % Pr(lam| Y), lam=1
      prob2 = Pr02 + Pr12 + Pr22 + Pr32;
      prob3 = Pr03 + Pr13 + Pr23 + Pr33;
      
      
      PROB(J_ITER,:,:)=[Pr00,Pr01,Pr02,Pr03;Pr10,Pr11,Pr12,Pr13;Pr20,Pr21,Pr22,Pr23;Pr30,Pr31,Pr32,Pr33];
      
      Pr_tt0(J_ITER) = prob0;
      Pr_tt1(J_ITER) = prob1;
      Pr_tt2(J_ITER) = prob2;
      Pr_tt3(J_ITER) = prob3;
      
      
      
      % collapsing
     BETA_LL0 = (Pr00 * BETA_TT00 + Pr10 * BETA_TT10 + Pr20 * BETA_TT20 + Pr30 * BETA_TT30) / prob0; 
     BETA_LL1 = (Pr01 * BETA_TT01 + Pr11 * BETA_TT11 + Pr21 * BETA_TT21 + Pr31 * BETA_TT31) / prob1; 
     BETA_LL2 = (Pr02 * BETA_TT02 + Pr12 * BETA_TT12 + Pr22 * BETA_TT22 + Pr32 * BETA_TT32) / prob2; 
     BETA_LL3 = (Pr03 * BETA_TT03 + Pr13 * BETA_TT13 + Pr23 * BETA_TT23 + Pr33 * BETA_TT33) / prob3;
    
      
      P_LL0 = (Pr00 * (P_TT00 + (BETA_LL0 - BETA_TT00) * (BETA_LL0 - BETA_TT00)')...
              +Pr10 * (P_TT10 + (BETA_LL0 - BETA_TT10) * (BETA_LL0 - BETA_TT10)')... 
              +Pr20 * (P_TT20 + (BETA_LL0 - BETA_TT20) * (BETA_LL0 - BETA_TT20)')... 
              +Pr30 * (P_TT30 + (BETA_LL0 - BETA_TT30) * (BETA_LL0 - BETA_TT30)') ) / prob0;
      
      P_LL1 = (Pr01 * (P_TT01 + (BETA_LL1 - BETA_TT01) * (BETA_LL1 - BETA_TT01)')...
              +Pr11 * (P_TT11 + (BETA_LL1 - BETA_TT11) * (BETA_LL1 - BETA_TT11)')... 
              +Pr21 * (P_TT21 + (BETA_LL1 - BETA_TT21) * (BETA_LL1 - BETA_TT21)')... 
              +Pr31 * (P_TT31 + (BETA_LL1 - BETA_TT31) * (BETA_LL1 - BETA_TT31)') ) / prob1;
          
      P_LL2 = (Pr02 * (P_TT02 + (BETA_LL2 - BETA_TT02) * (BETA_LL2 - BETA_TT02)')...
              +Pr12 * (P_TT12 + (BETA_LL2 - BETA_TT12) * (BETA_LL2 - BETA_TT12)')... 
              +Pr22 * (P_TT22 + (BETA_LL2 - BETA_TT22) * (BETA_LL2 - BETA_TT22)')... 
              +Pr32 * (P_TT32 + (BETA_LL2 - BETA_TT32) * (BETA_LL2 - BETA_TT32)') ) / prob2;
          
      P_LL3 = (Pr03 * (P_TT03 + (BETA_LL3 - BETA_TT03) * (BETA_LL3 - BETA_TT03)')...
              +Pr13 * (P_TT13 + (BETA_LL3 - BETA_TT13) * (BETA_LL3 - BETA_TT13)')... 
              +Pr23 * (P_TT23 + (BETA_LL3 - BETA_TT23) * (BETA_LL3 - BETA_TT23)')... 
              +Pr33 * (P_TT33 + (BETA_LL3 - BETA_TT33) * (BETA_LL3 - BETA_TT33)') ) / prob3;
       
          
          
       
      BE_tt0(:,J_ITER) = [BETA_LL0];
      BE_tt1(:,J_ITER) = [BETA_LL1];
      BE_tt2(:,J_ITER) = [BETA_LL2];
      BE_tt3(:,J_ITER) = [BETA_LL3];
      
      
      P_tt0(:,:,J_ITER)  = [P_LL0];
      P_tt1(:,:,J_ITER)  = [P_LL1];
      P_tt2(:,:,J_ITER)  = [P_LL2];
      P_tt3(:,:,J_ITER)  = [P_LL3];
      
 
      
     
      
      % store filtering
      BE_tl00(:,J_ITER) = [BETA_TL00];
      BE_tl01(:,J_ITER) = [BETA_TL01];
      BE_tl02(:,J_ITER) = [BETA_TL02];
      BE_tl03(:,J_ITER) = [BETA_TL03];
      
      BE_tl10(:,J_ITER) = [BETA_TL10];
      BE_tl11(:,J_ITER) = [BETA_TL11];
      BE_tl12(:,J_ITER) = [BETA_TL12];
      BE_tl13(:,J_ITER) = [BETA_TL13];
    
      BE_tl20(:,J_ITER) = [BETA_TL20];
      BE_tl21(:,J_ITER) = [BETA_TL21];
      BE_tl22(:,J_ITER) = [BETA_TL22];
      BE_tl23(:,J_ITER) = [BETA_TL23];
      
      BE_tl30(:,J_ITER) = [BETA_TL30];
      BE_tl31(:,J_ITER) = [BETA_TL31];
      BE_tl32(:,J_ITER) = [BETA_TL32];
      BE_tl33(:,J_ITER) = [BETA_TL33];
      
      
      P_tl00(:,:,J_ITER)  = [P_TL00];
      P_tl01(:,:,J_ITER)  = [P_TL01]; 
      P_tl02(:,:,J_ITER)  = [P_TL02];
      P_tl03(:,:,J_ITER)  = [P_TL03];
       
      P_tl10(:,:,J_ITER)  = [P_TL10];
      P_tl11(:,:,J_ITER)  = [P_TL11]; 
      P_tl12(:,:,J_ITER)  = [P_TL12];
      P_tl13(:,:,J_ITER)  = [P_TL13];
      
      P_tl20(:,:,J_ITER)  = [P_TL20];
      P_tl21(:,:,J_ITER)  = [P_TL21]; 
      P_tl22(:,:,J_ITER)  = [P_TL22];
      P_tl23(:,:,J_ITER)  = [P_TL23];
       
      P_tl30(:,:,J_ITER)  = [P_TL30];
      P_tl31(:,:,J_ITER)  = [P_TL31]; 
      P_tl32(:,:,J_ITER)  = [P_TL32];
      P_tl33(:,:,J_ITER)  = [P_TL33];
      
      
      
      J_ITER;
      
  end

  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
  %SM
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  BETA_tT0= BETA_LL0;
  BETA_tT1= BETA_LL1;
  BETA_tT2= BETA_LL2;
  BETA_tT3= BETA_LL3;
  
  P_tT0   = P_LL0;
  P_tT1   = P_LL1;
  P_tT2   = P_LL2;
  P_tT3   = P_LL3;
  
  
      smoothed(T,:) = Pr_tt0(T)*BETA_tT0'+Pr_tt1(T)*BETA_tT1'+Pr_tt2(T)*BETA_tT2'+Pr_tt3(T)*BETA_tT3' ;
     
  
  pr_sm0(T)=Pr_tt0(T);
  pr_sm1(T)=Pr_tt1(T);
  pr_sm2(T)=Pr_tt2(T);
  pr_sm3(T)=Pr_tt3(T);
   
   
   
  for  j_iter=T-1:-1:1 
    
      P00=P_tt0(:,:,j_iter)*F'*inv(P_tl00(:,:,j_iter+1));
      P01=P_tt0(:,:,j_iter)*F'*inv(P_tl01(:,:,j_iter+1));
      P02=P_tt0(:,:,j_iter)*F'*inv(P_tl02(:,:,j_iter+1));
      P03=P_tt0(:,:,j_iter)*F'*inv(P_tl03(:,:,j_iter+1));
      
      
      P10=P_tt1(:,:,j_iter)*F'*inv(P_tl10(:,:,j_iter+1));
      P11=P_tt1(:,:,j_iter)*F'*inv(P_tl11(:,:,j_iter+1));
      P12=P_tt1(:,:,j_iter)*F'*inv(P_tl12(:,:,j_iter+1));
      P13=P_tt1(:,:,j_iter)*F'*inv(P_tl13(:,:,j_iter+1));
      
      P20=P_tt2(:,:,j_iter)*F'*inv(P_tl20(:,:,j_iter+1));
      P21=P_tt2(:,:,j_iter)*F'*inv(P_tl21(:,:,j_iter+1));
      P22=P_tt2(:,:,j_iter)*F'*inv(P_tl22(:,:,j_iter+1));
      P23=P_tt2(:,:,j_iter)*F'*inv(P_tl23(:,:,j_iter+1));
      
      
      P30=P_tt3(:,:,j_iter)*F'*inv(P_tl30(:,:,j_iter+1));
      P31=P_tt3(:,:,j_iter)*F'*inv(P_tl31(:,:,j_iter+1));
      P32=P_tt3(:,:,j_iter)*F'*inv(P_tl32(:,:,j_iter+1));
      P33=P_tt3(:,:,j_iter)*F'*inv(P_tl33(:,:,j_iter+1));
      
     
       % one step ahead
      BETA_tT00 = BE_tt0(:,j_iter) + P00*(BETA_tT0 - BE_tl00(:,j_iter+1));   
      BETA_tT01 = BE_tt0(:,j_iter) + P01*(BETA_tT1 - BE_tl01(:,j_iter+1));  
      BETA_tT02 = BE_tt0(:,j_iter) + P02*(BETA_tT2 - BE_tl02(:,j_iter+1));   
      BETA_tT03 = BE_tt0(:,j_iter) + P03*(BETA_tT3 - BE_tl03(:,j_iter+1)); 
      
      BETA_tT10 = BE_tt1(:,j_iter) + P10*(BETA_tT0 - BE_tl10(:,j_iter+1));   
      BETA_tT11 = BE_tt1(:,j_iter) + P11*(BETA_tT1 - BE_tl11(:,j_iter+1));  
      BETA_tT12 = BE_tt1(:,j_iter) + P12*(BETA_tT2 - BE_tl12(:,j_iter+1));   
      BETA_tT13 = BE_tt1(:,j_iter) + P13*(BETA_tT3 - BE_tl13(:,j_iter+1)); 
      
      BETA_tT20 = BE_tt2(:,j_iter) + P20*(BETA_tT0 - BE_tl20(:,j_iter+1));   
      BETA_tT21 = BE_tt2(:,j_iter) + P21*(BETA_tT1 - BE_tl21(:,j_iter+1));  
      BETA_tT22 = BE_tt2(:,j_iter) + P22*(BETA_tT2 - BE_tl22(:,j_iter+1));   
      BETA_tT23 = BE_tt2(:,j_iter) + P23*(BETA_tT3 - BE_tl23(:,j_iter+1)); 
      
      BETA_tT30 = BE_tt3(:,j_iter) + P30*(BETA_tT0 - BE_tl30(:,j_iter+1));   
      BETA_tT31 = BE_tt3(:,j_iter) + P31*(BETA_tT1 - BE_tl31(:,j_iter+1));  
      BETA_tT32 = BE_tt3(:,j_iter) + P32*(BETA_tT2 - BE_tl32(:,j_iter+1));   
      BETA_tT33 = BE_tt3(:,j_iter) + P33*(BETA_tT3 - BE_tl33(:,j_iter+1)); 
      
      
      
      
      P_tT00 = P_tt0(:,:,j_iter) + P00 * (P_tT0 -P_tl00(:,:,j_iter+1)) * P00';
      P_tT01 = P_tt0(:,:,j_iter) + P01 * (P_tT1 -P_tl01(:,:,j_iter+1)) * P01';
      P_tT02 = P_tt0(:,:,j_iter) + P02 * (P_tT2 -P_tl02(:,:,j_iter+1)) * P02';
      P_tT03 = P_tt0(:,:,j_iter) + P03 * (P_tT3 -P_tl03(:,:,j_iter+1)) * P03';
      
      
      P_tT10 = P_tt1(:,:,j_iter) + P10 * (P_tT0 -P_tl10(:,:,j_iter+1)) * P10';
      P_tT11 = P_tt1(:,:,j_iter) + P11 * (P_tT1 -P_tl11(:,:,j_iter+1)) * P11';
      P_tT12 = P_tt1(:,:,j_iter) + P12 * (P_tT2 -P_tl12(:,:,j_iter+1)) * P12';
      P_tT13 = P_tt1(:,:,j_iter) + P13 * (P_tT3 -P_tl13(:,:,j_iter+1)) * P13';
      
      P_tT20 = P_tt2(:,:,j_iter) + P20 * (P_tT0 -P_tl20(:,:,j_iter+1)) * P20';
      P_tT21 = P_tt2(:,:,j_iter) + P21 * (P_tT1 -P_tl21(:,:,j_iter+1)) * P21';
      P_tT22 = P_tt2(:,:,j_iter) + P22 * (P_tT2 -P_tl22(:,:,j_iter+1)) * P22';
      P_tT23 = P_tt2(:,:,j_iter) + P23 * (P_tT3 -P_tl23(:,:,j_iter+1)) * P23';
      
      
      P_tT30 = P_tt3(:,:,j_iter) + P30 * (P_tT0 -P_tl20(:,:,j_iter+1)) * P30';
      P_tT31 = P_tt3(:,:,j_iter) + P31 * (P_tT1 -P_tl21(:,:,j_iter+1)) * P31';
      P_tT32 = P_tt3(:,:,j_iter) + P32 * (P_tT2 -P_tl22(:,:,j_iter+1)) * P32';
      P_tT33 = P_tt3(:,:,j_iter) + P33 * (P_tT3 -P_tl23(:,:,j_iter+1)) * P33';
      
     
      
      % collapsing
      
%       Pr00 = pr_sm0(j_iter+1)    * Pr_tt0(j_iter) * a*b / Pr_tl0(j_iter+1) ;
%       Pr01 = pr_sm1(j_iter+1)    * Pr_tt0(j_iter) * a*(1-b) / Pr_tl1(j_iter+1);
%       Pr02 = pr_sm2(j_iter+1)    * Pr_tt0(j_iter) * (1-a)*b / Pr_tl2(j_iter+1) ;
%       Pr03 = pr_sm3(j_iter+1)    * Pr_tt0(j_iter) * (1-a)*(1-b) / Pr_tl3(j_iter+1);
%       
%       Pr10 = pr_sm0(j_iter+1)    * Pr_tt1(j_iter) * a*b / Pr_tl0(j_iter+1) ;
%       Pr11 = pr_sm1(j_iter+1)    * Pr_tt1(j_iter) * a*(1-b) / Pr_tl1(j_iter+1);
%       Pr12 = pr_sm2(j_iter+1)    * Pr_tt1(j_iter) * (1-a)*b / Pr_tl2(j_iter+1) ;
%       Pr13 = pr_sm3(j_iter+1)    * Pr_tt1(j_iter) * (1-a)*(1-b) / Pr_tl3(j_iter+1);
%       
%       Pr20 = pr_sm0(j_iter+1)    * Pr_tt2(j_iter) * a*b / Pr_tl0(j_iter+1) ;
%       Pr21 = pr_sm1(j_iter+1)    * Pr_tt2(j_iter) * a*(1-b) / Pr_tl1(j_iter+1);
%       Pr22 = pr_sm2(j_iter+1)    * Pr_tt2(j_iter) * (1-a)*b / Pr_tl2(j_iter+1) ;
%       Pr23 = pr_sm3(j_iter+1)    * Pr_tt2(j_iter) * (1-a)*(1-b) / Pr_tl3(j_iter+1);
%       
%       Pr30 = pr_sm0(j_iter+1)    * Pr_tt3(j_iter) * a*b / Pr_tl0(j_iter+1) ;
%       Pr31 = pr_sm1(j_iter+1)    * Pr_tt3(j_iter) * a*(1-b) / Pr_tl1(j_iter+1);
%       Pr32 = pr_sm2(j_iter+1)    * Pr_tt3(j_iter) * (1-a)*b / Pr_tl2(j_iter+1) ;
%       Pr33 = pr_sm3(j_iter+1)    * Pr_tt3(j_iter) * (1-a)*(1-b) / Pr_tl3(j_iter+1);
      
     
        

% Pr00 = PRO_00(j_iter+1);
% Pr01 = PRO_01(j_iter+1);
% Pr10 = PRO_10(j_iter+1);
% Pr11 = PRO_11(j_iter+1);


%       
      Pr00 = pr_sm0(j_iter+1)    * Pr_tt0(j_iter) * a*b * Cd(j_iter+1,1)  /( LL(j_iter+1)*Pr_tt0(j_iter+1));
      Pr01 = pr_sm1(j_iter+1)    * Pr_tt0(j_iter) * a*(1-b) * Cd(j_iter+1,2) /( LL(j_iter+1)*Pr_tt1(j_iter+1));
      Pr02 = pr_sm2(j_iter+1)    * Pr_tt0(j_iter) * (1-a)*b * Cd(j_iter+1,3)  /( LL(j_iter+1)*Pr_tt2(j_iter+1));
      Pr03 = pr_sm3(j_iter+1)    * Pr_tt0(j_iter) * (1-a)*(1-b) * Cd(j_iter+1,4) /( LL(j_iter+1)*Pr_tt3(j_iter+1));      
      
      
      Pr10 = pr_sm0(j_iter+1)    * Pr_tt1(j_iter) * a*b * Cd(j_iter+1,5) /( LL(j_iter+1)*Pr_tt0(j_iter+1));
      Pr11 = pr_sm1(j_iter+1)    * Pr_tt1(j_iter) * a*(1-b) * Cd(j_iter+1,6) /( LL(j_iter+1)*Pr_tt1(j_iter+1));
      Pr12 = pr_sm2(j_iter+1)    * Pr_tt1(j_iter) * (1-a)*b * Cd(j_iter+1,7) /( LL(j_iter+1)*Pr_tt2(j_iter+1));
      Pr13 = pr_sm3(j_iter+1)    * Pr_tt1(j_iter) * (1-a)*(1-b) * Cd(j_iter+1,8) /( LL(j_iter+1)*Pr_tt3(j_iter+1));
      
      Pr20 = pr_sm0(j_iter+1)    * Pr_tt2(j_iter) * a*b * Cd(j_iter+1,9)  /( LL(j_iter+1)*Pr_tt0(j_iter+1));
      Pr21 = pr_sm1(j_iter+1)    * Pr_tt2(j_iter) * a*(1-b) * Cd(j_iter+1,10) /( LL(j_iter+1)*Pr_tt1(j_iter+1));
      Pr22 = pr_sm2(j_iter+1)    * Pr_tt2(j_iter) * (1-a)*b * Cd(j_iter+1,11)  /( LL(j_iter+1)*Pr_tt2(j_iter+1));
      Pr23 = pr_sm3(j_iter+1)    * Pr_tt2(j_iter) * (1-a)*(1-b) * Cd(j_iter+1,12) /( LL(j_iter+1)*Pr_tt3(j_iter+1));      
      
      
      Pr30 = pr_sm0(j_iter+1)    * Pr_tt3(j_iter) * a*b * Cd(j_iter+1,13) /( LL(j_iter+1)*Pr_tt0(j_iter+1));
      Pr31 = pr_sm1(j_iter+1)    * Pr_tt3(j_iter) * a*(1-b) * Cd(j_iter+1,14) /( LL(j_iter+1)*Pr_tt1(j_iter+1));
      Pr32 = pr_sm2(j_iter+1)    * Pr_tt3(j_iter) * (1-a)*b * Cd(j_iter+1,15) /( LL(j_iter+1)*Pr_tt2(j_iter+1));
      Pr33 = pr_sm3(j_iter+1)    * Pr_tt3(j_iter) * (1-a)*(1-b) * Cd(j_iter+1,16) /( LL(j_iter+1)*Pr_tt3(j_iter+1));
      
      % smoothed probabilities
       pr_sm0(j_iter)=Pr00+Pr01+Pr02+Pr03 ;   
       pr_sm1(j_iter)=Pr10+Pr11+Pr12+Pr13 ;
       pr_sm2(j_iter)=Pr20+Pr21+Pr22+Pr23 ;   
       pr_sm3(j_iter)=Pr30+Pr31+Pr32+Pr33 ;
       
       
      %[pr_sm0(j_iter),  Pr_tt0(j_iter),PRO_01(j_iter+1)+PRO_00(j_iter+1)]
      
      pr_sm0(j_iter)+pr_sm1(j_iter)+pr_sm2(j_iter)+pr_sm3(j_iter);
      
       
      
      
      
      BETA_tT0 = (Pr00 * BETA_tT00 + Pr01 * BETA_tT01 +Pr02 * BETA_tT02 + Pr03 * BETA_tT03) / pr_sm0(j_iter); 
      BETA_tT1 = (Pr10 * BETA_tT10 + Pr11 * BETA_tT11 +Pr12 * BETA_tT12 + Pr13 * BETA_tT13) / pr_sm1(j_iter); 
      BETA_tT2 = (Pr20 * BETA_tT20 + Pr21 * BETA_tT21 +Pr22 * BETA_tT22 + Pr23 * BETA_tT23) / pr_sm2(j_iter); 
      BETA_tT3 = (Pr30 * BETA_tT30 + Pr31 * BETA_tT31 +Pr32 * BETA_tT32 + Pr33 * BETA_tT33) / pr_sm3(j_iter); 
      
      
   
     
      P_tT0 = (Pr00 * (P_tT00 + (BETA_tT0 - BETA_tT00) * (BETA_tT0 - BETA_tT00)')...
          +Pr01 * (P_tT01 + (BETA_tT0 - BETA_tT01) * (BETA_tT0 - BETA_tT01)') ....
          +Pr02 * (P_tT02 + (BETA_tT0 - BETA_tT02) * (BETA_tT0 - BETA_tT02)')...
          +Pr03 * (P_tT03 + (BETA_tT0 - BETA_tT03) * (BETA_tT0 - BETA_tT03)') ) / pr_sm0(j_iter);

      P_tT1 = (Pr10 * (P_tT10 + (BETA_tT1 - BETA_tT10) * (BETA_tT1 - BETA_tT10)')...
          +Pr11 * (P_tT11 + (BETA_tT1 - BETA_tT11) * (BETA_tT1 - BETA_tT11)')...
          +Pr12 * (P_tT12 + (BETA_tT1 - BETA_tT12) * (BETA_tT1 - BETA_tT12)')...
          +Pr13 * (P_tT13 + (BETA_tT1 - BETA_tT13) * (BETA_tT1 - BETA_tT13)') ) / pr_sm1(j_iter);
      
      P_tT2 = (Pr20 * (P_tT20 + (BETA_tT2 - BETA_tT20) * (BETA_tT2 - BETA_tT20)')...
          +Pr21 * (P_tT21 + (BETA_tT2 - BETA_tT21) * (BETA_tT2 - BETA_tT21)') ....
          +Pr22 * (P_tT22 + (BETA_tT2 - BETA_tT22) * (BETA_tT2 - BETA_tT22)')...
          +Pr23 * (P_tT23 + (BETA_tT2 - BETA_tT23) * (BETA_tT2 - BETA_tT23)') ) / pr_sm2(j_iter);

      P_tT1 = (Pr30 * (P_tT30 + (BETA_tT3 - BETA_tT30) * (BETA_tT3 - BETA_tT30)')...
          +Pr31 * (P_tT31 + (BETA_tT3 - BETA_tT31) * (BETA_tT3 - BETA_tT31)')...
          +Pr32 * (P_tT32 + (BETA_tT3 - BETA_tT32) * (BETA_tT3 - BETA_tT32)')...
          +Pr33 * (P_tT33 + (BETA_tT3 - BETA_tT33) * (BETA_tT3 - BETA_tT33)') ) / pr_sm3(j_iter);
     
      
      
%       P_tT1 = (Pr10 * (P_tT10 + (BETA_tT1 - BETA_tT10) * (BETA_tT1 - BETA_tT10)')...
%           +Pr11 * (P_tT11 + (BETA_tT1 - BETA_tT11) * (BETA_tT1 - BETA_tT11)') ) /(1-pr_sm0(j_iter)) ;
%       
  

B_TT = BETA_tT0*pr_sm0(j_iter) + BETA_tT1*pr_sm1(j_iter) +BETA_tT2*pr_sm2(j_iter) + BETA_tT3*pr_sm3(j_iter);

      
      
      
      
      
  % smoothed process
      smoothed(j_iter,1) = B_TT(1);
      smoothed(j_iter,2) = B_TT(2);
      smoothed(j_iter,3) = B_TT(3);
      smoothed(j_iter,4) = B_TT(4);
      
      
      j_iter=j_iter-1;
  end
  
  cycle=cycle(1:T,:);
  smoothed=smoothed(1:T,:);
        
      