function y=filter_uc_ur_m11(PRMTR1);

global START; 
global T;
global yy
global I

     BETA_MAT=zeros(T,2);
     
     LIK_MAT=zeros(T,1);
     
     PRMTR=trans_m11(PRMTR1);
     
     
     %PRMTR=PRMTR1;

%      PRMTR=[0.000000001,.1513,.4145,.99712,1.5214,-0.59984,-.2864];
%LOCATE 15,1;  PRMTR';

     SN=PRMTR(1); % @s.e. of the random walk component@
     SE=PRMTR(2);  %@s.e. of the AR component@
     SNE=PRMTR(3);% @ COV(n,e) @
     mu=PRMTR(4);
     phi1=PRMTR(5);
     phi2=PRMTR(6);
     %d=PRMTR(7);

     %d=0; % NO BREAK CASE
     
     F=[1,0,0;0,phi1,phi2;0,1,0];
     F1 = F(2:3,2:3);%pick out I(0) part @
     H=[1,1,0];%   measurement equation @

   
     Q= zeros(3,3);  %           @ E[V(t)V(t)'] @

     Q(1,1)=SN^2;
     Q(2,2)=SE^2;
     Q(1,2)=SNE;
     Q(2,1)=SNE;

     Q1 =Q(2:3,2:3); % cov matrix of I(0) part @
     R= 0;%           @ cov matrix of error in measurement eqn @

     BETA_LL=[yy(1);0;0];%             @ starting values @

          
      P_LL = zeros(3,3);
          P_LL1 = inv( (eye(4)-kron(F1,F1)) )*reshape(Q1,4,1);
          P_LL1 = reshape(P_LL1',2,2);
          P_LL(1,1)=100000000;
          P_LL(2:3,2:3)=P_LL1;

          muvec = [mu;0;0]; 

          J_ITER=1;
          
while J_ITER<T+1;

      
      BETA_TL = muvec + F*BETA_LL ;
      P_TL = F*P_LL*F' + Q;

      vt=yy(J_ITER,1) - H * BETA_TL ;% @prediction error@

      ft= H * P_TL * H' + R;  %     @variance of forecast error@

      BETA_TT= BETA_TL + P_TL * H' * inv(ft) * vt;

      P_TT= P_TL - P_TL * H' * inv(ft) * H * P_TL;


      BETA_MAT(J_ITER,:)=[BETA_TT(1,1),BETA_TT(2,1)];
      
      BETA_LL=BETA_TT;
 
      P_LL=P_TT;

      J_ITER=J_ITER+1;
end

y=(BETA_MAT(START:T,:));

