clear all

randn('state', 4648)
global START;
global T;
global dyy;






T1=200+5;
I=101+5; % break happens at t=100;
START=1;
t=1:T1; % deterministic trend
t=t';


rep=200; % number of replication


It=zeros(1,T1);
It(1,I:T1)=1:T1-I+1;
It=It';

b=1;
b=.95;
%d=0;

%D=0:-.1:-1.5;
D=[-.1,-.4,-.6,-0.29];


Pmean=zeros(6,length(D));
Pmedian=zeros(6,length(D));
Psd=zeros(6,length(D));
Value=zeros(length(D),rep,1);


for i=1:length(D)
       
d=D(i);

redo=0;

PRM=zeros(6,rep);
Eflag=zeros(rep,1);
Fval=zeros(rep,1);

while redo<rep
%redos=12;
%redos=28; 

%for redo=1:6
e=zeros(T1,1);
e=.94*randn(T1,1);

% making cyclical components
eph1=1.28;
eph2=-.38;

c=zeros(1,T1);

c(1)=e(1);
c(2)=eph1*c(1)+e(2);

for j=3:T1
    c(j)=eph1*c(j-1)+eph2*c(j-2)+e(j);
end
c=c';


   % data generation
yy=zeros(T1,1);
yy=724.18+b*t+d*It+c;  % DGP
yy=yy(6:T1);

dyy=yy(2:T1-5)-yy(1:T1-1-5);
T=length(dyy);

%if redo>=redos
% ML estimation
START=1;%   @ startup values for VEVD of likelihood @
PRMTR_IN=[0.0311,2.0386,0.1190,0.8156,1.1148,-0.0180];%        @Initial values of the parameters @
PRMTR_IN=[0.0311, 2.0389, 0.1190, 0.8156, -1.0543, 0.5188];
PRMTR_IN=PRMTR_IN';
%maximize likelihood function





    
options=optimset('MaxFunEvals',[],'maxiter',[],'LargeScale','off','display','off','TolX',1e-6);

[xout,fval,exitflag,output,grad,hess]=fminunc(@lik_fcn_ari,PRMTR_IN,options);
prm_fnl=trans_ari_m11(xout);
    fval
    hess;
    exitflag
    
        if fval==0
            exitflag=0;
            22
        end
        
         if rcond(hess)<eps
             exitflag=0;
             11
         end

        exitflag




% end
% end
% end
% break


 if exitflag>0
        redo=redo+1;
        PRM(:,redo)=prm_fnl;
        Eflag(redo,1)=exitflag;
        Fval(redo,1)=fval;
        
        %making residuals

        phi1=prm_fnl(2);
        phi2=prm_fnl(3);
        mu=prm_fnl(4);
        th1=prm_fnl(5);
        th2=prm_fnl(6);
        
        
        et=zeros(T,1);
        for w=3:T
            et(w)=(dyy(w)-mu)-phi1*(dyy(w-1)-mu)-phi2*(dyy(w-2)-mu)-th1*et(w-1)-th2*et(w-2);
        end
        
        sig=et;
        ct=zeros(T,2);
        
        SIG(:,redo)=sig;
        
        
        Y(:,redo)=dyy;
    end
       
       
        [d, redo]
    
     
dyy=zeros(T,1);
 
end
Value(i,:,:)=Fval;

Pmean(:,i)=mean(PRM,2); % mean or median
Pmedian(:,i)=median(PRM,2);
Psd(:,i)=std(PRM,0,2);

SIGmedian(:,i)=median(SIG,2);
redo=1;

end


lsig=1:length(SIGmedian);


% figure
% plot(lsig,SIGmedian)
% title('ARIMA residual')
% %axis([0,T,-1,1])
% 






%save ('S:\Project_m11\simulation\arima212_final')