function y=lik_fcn_ari(PRMTR1);

     global T;
     global START;
     global dyy;
     PRMTR=trans_ari_m11(PRMTR1);

     qq=0;
     
     %I=100; % indicator function
%    PRMTR = PRMTR1; @



     SE=PRMTR(1);%  @s.e. of the random walk component@
     phi1=PRMTR(2);%  @s.e. of the AR component@
     phi2=PRMTR(3);% @ COV(n,e) @
     mu=PRMTR(4);
     theta1=PRMTR(5);
     theta2=PRMTR(6);

     % d=PRMTR(7);
     
     F=[phi1,phi2,theta1,theta2;1,0,0,0;0,0,0,0;0,0,1,0];

     H=[1,0,0,0]; %                 @ measurement equation @


     Q=SE^2;%             @ E(V(t)V(t)') @
    G=[1;0;1;0];


     R= 0;   %                   @ cov matrix of error in measurement eqn @

    BETA_LL=zeros(4,1); %       @ starting values @



     %@ variance matrix of initial state vector @
P_LL = inv( (eye(16)-kron(F,F)) )*reshape(G*Q*G',16,1);
  if rcond(eye(16)-kron(F,F))<eps
     y=0;qq=1;return
  end
  
 P_LL=  reshape(P_LL,4,4);
%   if rcond(P_LL)<eps
%       y=0;qq=1;return
%   end
                
         


LIK_MAT=zeros(T,1);

J_ITER = 1;


while J_ITER<T+1;

      BETA_TL = F*BETA_LL ;

      P_TL = F*P_LL*F' + G*Q*G';

      vt=dyy(J_ITER,1) - mu - H*BETA_TL ;% @prediction error@

      ft= H * P_TL * H' + R;%       @variance of forecast error@

      BETA_TT= BETA_TL + P_TL * H' * inv(ft) * vt;
      
      if rcond(ft)<eps
         qq=1;
          break 
      end

      P_TT= P_TL - P_TL * H' * inv(ft) * H * P_TL;

      LIK_MAT(J_ITER,1) =  0.5*(log(2*pi*ft) + vt^2/ft);

      BETA_LL=BETA_TT;

      P_LL=P_TT;

J_ITER=J_ITER+1;
   

end



VAL = sum(LIK_MAT(START:T,1));

if qq==0
    y=VAL;
else
    y=0;
end

qq;
