function y=lik_fcn_uc0_m11(PRMTR1);

global START; 
global T;
global yy;
global I
PRMTR=Trans_uc0_m11(PRMTR1);

qq=0;

SN=PRMTR(1,1);  
     SE=PRMTR(1,2);  
     SNE=PRMTR(1,3);
     mu=PRMTR(1,4);
     phi1=PRMTR(1,5);
     phi2=PRMTR(1,6);
     %d=PRMTR(1,7);
  
     F=[1,0,0;0,phi1,phi2;0,1,0];
     F1 = F(2:3,2:3); %pick out I(0) part @
     H=[1,1,0];%   measurement equation @
   

     Q= zeros(3,3);% @ E[V(t)V(t)'] @

     Q(1,1)=SN^2;
     Q(2,2)=SE^2;
     Q(1,2)=SNE;
     Q(2,1)=SNE;

     Q1 =Q(2:3,2:3); % cov matrix of I(0) part @
     R= 0;%           @ cov matrix of error in measurement eqn @

     BETA_LL=[yy(1,1);0;0];%             @ starting values @

     %@ variance matrix of initial state vector @


          P_LL = zeros(3,3);
          P_LL1 = inv( (eye(4)-kron(F1,F1)) )*reshape(Q1,4,1);
          
           if rcond(eye(4)-kron(F1,F1))<eps
                y=0;qq=1;return
            end
          
          P_LL1 = reshape(P_LL1',2,2);
          P_LL(1,1)=100000000;
          P_LL(2:3,2:3)=P_LL1;
          P_LL;
          
     LIK_MAT=zeros(T,1); % 
J_ITER = 1;


while J_ITER<T+1;


      muvec = [mu;0;0]; 
        
      BETA_TL = muvec + F*BETA_LL; 
      P_TL = F*P_LL*F' + Q;

      vt=yy(J_ITER,1) - H * BETA_TL; % @predicTion error@

      ft= H * P_TL * H' + R;  %     @variance of forecasT error@

      BETA_TT= BETA_TL + P_TL * H' * inv(ft) * vt;
      
       if rcond(ft)<eps
         qq=1;
          break 
      end

      P_TT= P_TL - P_TL * H' * inv(ft) * H * P_TL;

      LIK_MAT(J_ITER,1) =  0.5*(log(2*pi*ft) + vt^2/ft);

      BETA_LL=BETA_TT;

      P_LL=P_TT;
      
      J_ITER=J_ITER+1;
end;

VAL = sum(LIK_MAT(START:T,1)); 

if qq==0
    y=VAL;
else
    y=0;
end

