/* Proc lnair1.prc
   Duffuse prior for initial Value
*/
proc lnair(x0,mm);
local vague;
clearg x1,x2,p1,p2,y1,e,kt,hs,lf,t;
clearg pp,qq,pp1,ppe,nx,j,kk;
vague=1e+6;


sec=x0[1];
phip=x0[2:1+nar];
serw=x0[rows(x0)];


phi[2,2:cols(phi)]=phip';

r=0;
q[1,1]=serw^2;
q[2,2]=sec^2;

nx=nar+1;
x1=zeros(nx,1);
p1=zeros(nx,nx);

qq=zeros(nar^2,1);
qq[1]=q[2,2];
pp=phi[2:rows(phi),2:cols(phi)];

@ -- Check eigenvalues -- @
ppe=eig(pp);
ppe=abs(ppe);
if maxc(ppe) .> .99;
 p1[2:nx,2:nx]=10000000*eye(nar);
else;
 pp1=inv(eye(nar^2) - (pp.*.pp))*qq;
 j=1; do while j <= nar;
  kk=nar*(j-1);
  p1[2:nx,j+1]=pp1[kk+1:kk+nar];
 j=j+1; endo;
endif;
p1[1,1]=vague;

/* Carry out filtering   */


lf=zeros(nobs,1);

t=1; do while t<=nobs;
 y1=xdat[t];
 @ Kalman Filter @
 x2=phi*x1;
 e=y1-s*x2;
 p2=phi*p1*phi'+g*q*g';
 hs=s*p2*s'+r;
 kt=p2*s'*(invpd(hs));
 x1=x2+kt*e;
 p1=(eye(rows(p1))-kt*s)*p2;
@ End Filter @

lf[t,1]=-0.5*(ln(det(hs))+e'(invpd(hs))*e);
t=t+1; endo;
retp(lf);
endp;
