function p = pathdef
%PATHDEF Search path defaults.
%   PATHDEF returns a string that can be used as input to MATLABPATH
%   in order to set the path.

  
%   Copyright 1984-2000 The MathWorks, Inc.
%   $Revision: 1.4 $ $Date: 2000/06/01 16:19:21 $

% PATH DEFINED HERE -- Don't change this line.

p = [...
'd:\perronwada\trend_estim;',...
'd:\perronwada\fourstates_sch;',...
matlabroot,'\toolbox\matlab\general;',...
matlabroot,'\toolbox\matlab\ops;',...
matlabroot,'\toolbox\matlab\lang;',...
matlabroot,'\toolbox\matlab\elmat;',...
matlabroot,'\toolbox\matlab\elfun;',...
matlabroot,'\toolbox\matlab\specfun;',...
matlabroot,'\toolbox\matlab\matfun;',...
matlabroot,'\toolbox\matlab\datafun;',...
matlabroot,'\toolbox\matlab\audio;',...
matlabroot,'\toolbox\matlab\polyfun;',...
matlabroot,'\toolbox\matlab\funfun;',...
matlabroot,'\toolbox\matlab\sparfun;',...
matlabroot,'\toolbox\matlab\graph2d;',...
matlabroot,'\toolbox\matlab\graph3d;',...
matlabroot,'\toolbox\matlab\specgraph;',...
matlabroot,'\toolbox\matlab\graphics;',...
matlabroot,'\toolbox\matlab\uitools;',...
matlabroot,'\toolbox\matlab\strfun;',...
matlabroot,'\toolbox\matlab\iofun;',...
matlabroot,'\toolbox\matlab\timefun;',...
matlabroot,'\toolbox\matlab\datatypes;',...
matlabroot,'\toolbox\matlab\verctrl;',...
matlabroot,'\toolbox\matlab\winfun;',...
matlabroot,'\toolbox\matlab\winfun\comcli;',...
matlabroot,'\toolbox\matlab\demos;',...
matlabroot,'\toolbox\local;',...
matlabroot,'\toolbox\simulink\simulink;',...
matlabroot,'\toolbox\simulink\blocks;',...
matlabroot,'\toolbox\simulink\components;',...
matlabroot,'\toolbox\simulink\fixedandfloat;',...
matlabroot,'\toolbox\simulink\fixedandfloat\fxpdemos;',...
matlabroot,'\toolbox\simulink\fixedandfloat\obsolete;',...
matlabroot,'\toolbox\simulink\simdemos;',...
matlabroot,'\toolbox\simulink\simdemos\aerospace;',...
matlabroot,'\toolbox\simulink\simdemos\automotive;',...
matlabroot,'\toolbox\simulink\simdemos\simfeatures;',...
matlabroot,'\toolbox\simulink\simdemos\simgeneral;',...
matlabroot,'\toolbox\simulink\simdemos\simnew;',...
matlabroot,'\toolbox\simulink\simdemos\simcpp;',...
matlabroot,'\toolbox\simulink\dee;',...
matlabroot,'\toolbox\simulink\dastudio;',...
matlabroot,'\toolbox\stateflow\stateflow;',...
matlabroot,'\toolbox\stateflow\sfdemos;',...
matlabroot,'\toolbox\stateflow\coder;',...
matlabroot,'\toolbox\rtw\rtw;',...
matlabroot,'\toolbox\rtw\rtwdemos;',...
matlabroot,'\toolbox\rtw\rtwdemos\rsimdemos;',...
matlabroot,'\toolbox\rtw\targets\asap2\asap2;',...
matlabroot,'\toolbox\rtw\targets\asap2\asap2\user;',...
matlabroot,'\toolbox\ccslink\ccslink;',...
matlabroot,'\toolbox\ccslink\ccsdemos;',...
matlabroot,'\toolbox\ccslink\rtdxblks;',...
matlabroot,'\toolbox\comm\comm;',...
matlabroot,'\toolbox\comm\commdemos;',...
matlabroot,'\toolbox\comm\commobsolete;',...
matlabroot,'\toolbox\commblks\commblks;',...
matlabroot,'\toolbox\commblks\commmasks;',...
matlabroot,'\toolbox\commblks\commmex;',...
matlabroot,'\toolbox\commblks\commblksdemos;',...
matlabroot,'\toolbox\commblks\commblksobsolete\commblksobsolete;',...
matlabroot,'\toolbox\compiler;',...
matlabroot,'\toolbox\control\control;',...
matlabroot,'\toolbox\control\ctrlguis;',...
matlabroot,'\toolbox\control\ctrlobsolete;',...
matlabroot,'\toolbox\control\ctrlutil;',...
matlabroot,'\toolbox\control\ctrldemos;',...
matlabroot,'\toolbox\daq\daq;',...
matlabroot,'\toolbox\daq\daqguis;',...
matlabroot,'\toolbox\daq\daqdemos;',...
matlabroot,'\toolbox\dspblks\dspblks;',...
matlabroot,'\toolbox\dspblks\dspmasks;',...
matlabroot,'\toolbox\dspblks\dspmex;',...
matlabroot,'\toolbox\dspblks\dspdemos;',...
matlabroot,'\toolbox\fixpoint;',...
matlabroot,'\toolbox\fuzzy\fuzzy;',...
matlabroot,'\toolbox\fuzzy\fuzdemos;',...
matlabroot,'\toolbox\ident\ident;',...
matlabroot,'\toolbox\ident\idobsolete;',...
matlabroot,'\toolbox\ident\idguis;',...
matlabroot,'\toolbox\ident\idutils;',...
matlabroot,'\toolbox\ident\iddemos;',...
matlabroot,'\toolbox\ident\idhelp;',...
matlabroot,'\toolbox\images\images;',...
matlabroot,'\toolbox\images\imdemos;',...
matlabroot,'\toolbox\imaq\imaq;',...
matlabroot,'\toolbox\imaq\imaqdemos;',...
matlabroot,'\toolbox\instrument\instrument;',...
matlabroot,'\toolbox\instrument\instrumentdemos;',...
matlabroot,'\toolbox\map\map;',...
matlabroot,'\toolbox\map\mapdisp;',...
matlabroot,'\toolbox\map\mapproj;',...
matlabroot,'\toolbox\ncd;',...
matlabroot,'\toolbox\nnet\nnet;',...
matlabroot,'\toolbox\nnet\nnutils;',...
matlabroot,'\toolbox\nnet\nncontrol;',...
matlabroot,'\toolbox\nnet\nndemos;',...
matlabroot,'\toolbox\nnet\nnobsolete;',...
matlabroot,'\toolbox\optim;',...
matlabroot,'\toolbox\simulink\perftools;',...
matlabroot,'\toolbox\simulink\simcoverage;',...
matlabroot,'\toolbox\rtw\accel;',...
matlabroot,'\toolbox\robust;',...
matlabroot,'\toolbox\sb2sl;',...
matlabroot,'\toolbox\signal\signal;',...
matlabroot,'\toolbox\signal\sigtools;',...
matlabroot,'\toolbox\signal\sptoolgui;',...
matlabroot,'\toolbox\signal\sigdemos;',...
matlabroot,'\toolbox\splines;',...
matlabroot,'\toolbox\stats;',...
matlabroot,'\toolbox\symbolic;',...
matlabroot,'\toolbox\rtw\targets\tic6000\tic6000;',...
matlabroot,'\toolbox\rtw\targets\tic6000\blks;',...
matlabroot,'\toolbox\vr\vr;',...
matlabroot,'\toolbox\vr\vrdemos;',...
matlabroot,'\toolbox\wavelet\wavelet;',...
matlabroot,'\toolbox\wavelet\wavedemo;',...
matlabroot,'\work;',...
     ...
];

p = [userpath,p];
