function y=pearson( x,param)

% Pearson distribution
% inputs: param(1): location parameter, m
%         param(2): dispersion parameter, tau^2
%         param(3): shape parameter
% output: density at X

global tau2
global bv



y=gamma(param(3))/gamma(param(3)-0.5)...
    *1/(sqrt(pi)*param(2)^(param(3)-0.5))...
    *1/(((x-param(1))^2+param(2))^param(3));